window.Gleam.initSearch([{"doc":"gramps","title":"gramps","content":"# gramps\n\n[![Package Version](https://img.shields.io/hexpm/v/gramps)](https://hex.pm/packages/gramps)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gramps/)\n\nSome helper data types and functions for WebSockets.\n\nCurrently only used in [stratus](https://github.com/rawhat/stratus) but will\neventually be used in [mist](https://github.com/rawhat/mist) as well.\n\nI will document this more, and am definitely open to adding / reshaping this to\nfit the needs of other packages!\n\n## Installation\n\n```sh\ngleam add gramps\n```\n\nIts documentation can be found at &lt;https://hexdocs.pm/gramps&gt;.\n","url":"index.html"},{"doc":"gramps","title":"ControlFrame","content":"pub type ControlFrame {\n  CloseFrame(payload_length: Int, payload: BitArray)\n  PingFrame(payload_length: Int, payload: BitArray)\n  PongFrame(payload_length: Int, payload: BitArray)\n}\n\nCloseFrame(payload_length: Int, payload: BitArray)\n\n\nPingFrame(payload_length: Int, payload: BitArray)\n\n\nPongFrame(payload_length: Int, payload: BitArray)\n\n\nSynonyms:\ngramps.ControlFrame\ngramps ControlFrame","url":"gramps.html#ControlFrame"},{"doc":"gramps","title":"DataFrame","content":"pub type DataFrame {\n  TextFrame(payload_length: Int, payload: BitArray)\n  BinaryFrame(payload_length: Int, payload: BitArray)\n}\n\nTextFrame(payload_length: Int, payload: BitArray)\n\n\nBinaryFrame(payload_length: Int, payload: BitArray)\n\n\nSynonyms:\ngramps.DataFrame\ngramps DataFrame","url":"gramps.html#DataFrame"},{"doc":"gramps","title":"DecodePacketError","content":"pub type DecodePacketError {\n  More(length: Int)\n  HttpError(reason: String)\n}\n\nMore(length: Int)\n\n\nHttpError(reason: String)\n\n\nSynonyms:\ngramps.DecodePacketError\ngramps DecodePacketError","url":"gramps.html#DecodePacketError"},{"doc":"gramps","title":"Frame","content":"pub type Frame {\n  Data(DataFrame)\n  Control(ControlFrame)\n  Continuation(length: Int, payload: BitArray)\n}\n\nData(DataFrame)\n\n\nControl(ControlFrame)\n\n\nContinuation(length: Int, payload: BitArray)\n\n\nSynonyms:\ngramps.Frame\ngramps Frame","url":"gramps.html#Frame"},{"doc":"gramps","title":"FrameParseError","content":"pub type FrameParseError {\n  NeedMoreData(BitArray)\n  InvalidFrame\n}\n\nNeedMoreData(BitArray)\n\n\nInvalidFrame\n\n\nSynonyms:\ngramps.FrameParseError\ngramps FrameParseError","url":"gramps.html#FrameParseError"},{"doc":"gramps","title":"PacketType","content":"pub type PacketType {\n  HttphBin\n  HttpBin\n}\n\nHttphBin\n\n\nHttpBin\n\n\nSynonyms:\ngramps.PacketType\ngramps PacketType","url":"gramps.html#PacketType"},{"doc":"gramps","title":"ParsedFrame","content":"pub type ParsedFrame {\n  Complete(Frame)\n  Incomplete(Frame)\n}\n\nComplete(Frame)\n\n\nIncomplete(Frame)\n\n\nSynonyms:\ngramps.ParsedFrame\ngramps ParsedFrame","url":"gramps.html#ParsedFrame"},{"doc":"gramps","title":"websocket_client_key","content":"pub const websocket_client_key: String = &quot;dGhlIHNhbXBsZSBub25jZQ==&quot;\n\nSynonyms:\ngramps.websocket_client_key\ngramps websocket_client_key","url":"gramps.html#websocket_client_key"},{"doc":"gramps","title":"aggregate_frames","content":"pub fn aggregate_frames(\n  frames: List(ParsedFrame),\n  previous: Option(Frame),\n  joined: List(Frame),\n) -&gt; Result(List(Frame), Nil)\n\nSynonyms:\ngramps.aggregate_frames\ngramps aggregate_frames","url":"gramps.html#aggregate_frames"},{"doc":"gramps","title":"frame_from_message","content":"pub fn frame_from_message(\n  message: BitArray,\n) -&gt; Result(#(ParsedFrame, BitArray), FrameParseError)\n\nSynonyms:\ngramps.frame_from_message\ngramps frame_from_message","url":"gramps.html#frame_from_message"},{"doc":"gramps","title":"frame_to_bytes_builder","content":"pub fn frame_to_bytes_builder(\n  frame: Frame,\n  mask: Option(BitArray),\n) -&gt; BytesBuilder\n\nSynonyms:\ngramps.frame_to_bytes_builder\ngramps frame_to_bytes_builder","url":"gramps.html#frame_to_bytes_builder"},{"doc":"gramps","title":"get_messages","content":"pub fn get_messages(\n  data: BitArray,\n  frames: List(ParsedFrame),\n) -&gt; #(List(ParsedFrame), BitArray)\n\nSynonyms:\ngramps.get_messages\ngramps get_messages","url":"gramps.html#get_messages"},{"doc":"gramps","title":"parse_websocket_key","content":"pub fn parse_websocket_key(key: String) -&gt; String\n\nSynonyms:\ngramps.parse_websocket_key\ngramps parse_websocket_key","url":"gramps.html#parse_websocket_key"},{"doc":"gramps","title":"read_request","content":"pub fn read_request(\n  data: BitArray,\n) -&gt; Result(#(Request(Nil), BitArray), DecodePacketError)\n\nSynonyms:\ngramps.read_request\ngramps read_request","url":"gramps.html#read_request"},{"doc":"gramps","title":"read_response","content":"pub fn read_response(\n  data: BitArray,\n) -&gt; Result(#(Response(Nil), BitArray), DecodePacketError)\n\nSynonyms:\ngramps.read_response\ngramps read_response","url":"gramps.html#read_response"},{"doc":"gramps","title":"to_binary_frame","content":"pub fn to_binary_frame(\n  data: BitArray,\n  mask: Bool,\n) -&gt; BytesBuilder\n\nSynonyms:\ngramps.to_binary_frame\ngramps to_binary_frame","url":"gramps.html#to_binary_frame"},{"doc":"gramps","title":"to_text_frame","content":"pub fn to_text_frame(data: String, mask: Bool) -&gt; BytesBuilder\n\nSynonyms:\ngramps.to_text_frame\ngramps to_text_frame","url":"gramps.html#to_text_frame"},{"doc":"gramps","title":"gramps","content":"","url":"gramps.html"}]);